diff --git a/contrib/amd/include/am_utils.h b/contrib/amd/include/am_utils.h
index 4098cd4..b7e55ce 100644
--- a/contrib/amd/include/am_utils.h
+++ b/contrib/amd/include/am_utils.h
@@ -766,131 +401,6 @@ extern void nfs_umounted(am_node *mp);
 # endif /* not NFS_VERSION3 */
 #endif /* HAVE_FS_NFS3 */
 
-/*
- * Un*x File System
- * Normal local disk file system.
- */
-#ifdef HAVE_FS_UFS
-extern am_ops ufs_ops;		/* Un*x file system */
-#endif /* HAVE_FS_UFS */
-
-
-/**************************************************************************/
-/*** Automounter file-system types, implemented by amd.			***/
-/**************************************************************************/
-
-/*
- * Automount File System
- */
-#ifdef HAVE_AM_FS_AUTO
-extern am_ops amfs_auto_ops;	/* Automount file system (this!) */
-extern am_ops amfs_toplvl_ops;	/* Top-level automount file system */
-extern am_ops amfs_root_ops;	/* Root file system */
-extern qelem amfs_auto_srvr_list;
-extern am_node *amfs_auto_lookuppn(am_node *mp, char *fname, int *error_return, int op);
-extern am_node *next_nonerror_node(am_node *xp);
-extern char *amfs_auto_match(am_opts *fo);
-extern fserver *find_amfs_auto_srvr(mntfs *);
-extern int amfs_auto_readdir(am_node *mp, nfscookie cookie, nfsdirlist *dp, nfsentry *ep, int count);
-extern int amfs_auto_umount(am_node *mp);
-extern int amfs_auto_fmount(am_node *mp);
-extern int amfs_auto_fumount(am_node *mp);
-#endif /* HAVE_AM_FS_AUTO */
-
-/*
- * Toplvl Automount File System
- */
-#ifdef HAVE_AM_FS_TOPLVL
-extern am_ops amfs_toplvl_ops;	/* Toplvl Automount file system */
-extern int amfs_toplvl_mount(am_node *mp);
-extern int amfs_toplvl_umount(am_node *mp);
-extern void amfs_toplvl_mounted(mntfs *mf);
-#endif /* HAVE_AM_FS_TOPLVL */
-
-/*
- * Direct Automount File System
- */
-#ifdef HAVE_AM_FS_DIRECT
-extern am_ops amfs_direct_ops;	/* Direct Automount file system (this too) */
-#endif /* HAVE_AM_FS_DIRECT */
-
-/*
- * Error File System
- */
-#ifdef HAVE_AM_FS_ERROR
-extern am_ops amfs_error_ops;	/* Error file system */
-extern am_node *amfs_error_lookuppn(am_node *mp, char *fname, int *error_return, int op);
-extern int amfs_error_readdir(am_node *mp, nfscookie cookie, nfsdirlist *dp, nfsentry *ep, int count);
-#endif /* HAVE_AM_FS_ERROR */
-
-/*
- * Inheritance File System
- */
-#ifdef HAVE_AM_FS_INHERIT
-extern am_ops amfs_inherit_ops;	/* Inheritance file system */
-#endif /* HAVE_AM_FS_INHERIT */
-
-/*
- * NFS mounts with local existence check.
- */
-#ifdef HAVE_AM_FS_NFSL
-extern am_ops amfs_nfsl_ops;	/* NFSL */
-#endif /* HAVE_AM_FS_NFSL */
-
-/*
- * Multi-nfs mounts.
- */
-#ifdef HAVE_AM_FS_NFSX
-extern am_ops amfs_nfsx_ops;	/* NFSX */
-#endif /* HAVE_AM_FS_NFSX */
-
-/*
- * NFS host - a whole tree.
- */
-#ifdef HAVE_AM_FS_HOST
-extern am_ops amfs_host_ops;	/* NFS host */
-#endif /* HAVE_AM_FS_HOST */
-
-/*
- * Program File System
- * This is useful for things like RVD.
- */
-#ifdef HAVE_AM_FS_PROGRAM
-extern am_ops amfs_program_ops;	/* Program File System */
-#endif /* HAVE_AM_FS_PROGRAM */
-
-/*
- * Symbolic-link file system.
- * A "filesystem" which is just a symbol link.
- */
-#ifdef HAVE_AM_FS_LINK
-extern am_ops amfs_link_ops;	/* Symlink FS */
-extern int amfs_link_fmount(mntfs *mf);
-#endif /* HAVE_AM_FS_LINK */
-
-/*
- * Symbolic-link file system, which also checks that the target of
- * the symlink exists.
- * A "filesystem" which is just a symbol link.
- */
-#ifdef HAVE_AM_FS_LINKX
-extern am_ops amfs_linkx_ops;	/* Symlink FS with existence check */
-#endif /* HAVE_AM_FS_LINKX */
-
-/*
- * Union file system
- */
-#ifdef HAVE_AM_FS_UNION
-extern am_ops amfs_union_ops;	/* Union FS */
-#endif /* HAVE_AM_FS_UNION */
-
-/*
- * Autofs file system
- */
-#ifdef HAVE_FS_AUTOFS
-extern am_ops autofs_ops;	/* (Sun) Autofs FS */
-#endif /* HAVE_FS_AUTOFS */
-
 
 /**************************************************************************/
 /*** DEBUGGING								***/
@@ -899,39 +409,39 @@ extern am_ops autofs_ops;	/* (Sun) Autofs FS */
 /*
  * DEBUGGING:
  */
+
 #ifdef DEBUG
 
-# define	D_ALL		(~0)
-# define	D_DAEMON	0x0001	/* Enter daemon mode */
+# define	D_ALL		(~(D_MTAB|D_HRTIME|D_XDRTRACE|D_DAEMON|D_FORK|D_AMQ))
+# define	D_DAEMON	0x0001	/* Don't enter daemon mode */
 # define	D_TRACE		0x0002	/* Do protocol trace */
 # define	D_FULL		0x0004	/* Do full trace */
 # define	D_MTAB		0x0008	/* Use local mtab */
-# define	D_AMQ		0x0010	/* Register amq program */
+# define	D_AMQ		0x0010	/* Don't register amq program */
 # define	D_STR		0x0020	/* Debug string munging */
-#  ifdef DEBUG_MEM
-# define	D_MEM		0x0040	/* Trace memory allocations */
-#  endif /* DEBUG_MEM */
-# define	D_FORK		0x0080	/* Fork server */
+# ifdef DEBUG_MEM
+#  define	D_MEM		0x0040	/* Trace memory allocations */
+# else /* not DEBUG_MEM */
+#  define	D_MEM		0x0000	/* Dummy */
+# endif /* not DEBUG_MEM */
+# define	D_FORK		0x0080	/* Don't fork server */
 		/* info service specific debugging (hesiod, nis, etc) */
 # define	D_INFO		0x0100
+# define	D_HRTIME	0x0200	/* Print high resolution time stamps */
+# define	D_XDRTRACE	0x0400	/* Trace xdr routines */
+# define	D_READDIR	0x0800	/* Show browsable_dir progress */
 
 /*
- * Normally, don't enter daemon mode, and don't register amq
+ * Test mode is test mode: don't daemonize, don't register amq, don't fork,
+ * don't touch system mtab, etc.
  */
-#  ifdef DEBUG_MEM
-# define	D_TEST	(~(D_DAEMON|D_MEM|D_STR))
-#  else /* not DEBUG_MEM */
-# define	D_TEST	(~(D_DAEMON|D_STR))
-#  endif /* not DEBUG_MEM */
+# define	D_TEST	(~(D_MEM|D_STR|D_XDRTRACE))
 
-# define	amuDebug(x)	if (debug_flags & (x))
-# define	dlog		amuDebug(D_FULL) dplog
-# define	amuDebugNo(x)	if (!(debug_flags & (x)))
+# define	amuDebug(x)	(debug_flags & (x))
+# define	dlog		if (amuDebug(D_FULL)) dplog
 
-/* debugging mount-table file to use */
-# ifndef DEBUG_MNTTAB
-#  define	DEBUG_MNTTAB	"./mnttab"
-# endif /* not DEBUG_MNTTAB */
+/* my favorite debugging tool -Erez */
+#define EZKDBG plog(XLOG_INFO,"EZK:%s:%s:%d\n",__FILE__,__FUNCTION__,__LINE__)
 
 # ifdef DEBUG_MEM
 /*
@@ -951,22 +461,34 @@ extern void malloc_verify(void);
 
 /* functions that depend solely on debugging */
 extern void print_nfs_args(const nfs_args_t *nap, u_long nfs_version);
+extern int debug_option (char *opt);
+extern void dplog(const char *fmt, ...)
+     __attribute__ ((__format__ (__printf__, 1, 2)));
 
 #else /* not DEBUG */
 
 /*
- * if not debugging, then simple perform free, and don't bother
- * resetting the pointer.
+ * If not debugging, then also reset the pointer.
+ * It's safer -- and besides, free() should do that anyway.
  */
-#  define	XFREE(x) free(x)
+#  define	XFREE(x) do { free((voidp)x); x = NULL;} while (0)
+
+#define		amuDebug(x)	(0)
+
+#ifdef __GNUC__
+#define		dlog(fmt...)
+#else  /* not __GNUC__ */
+/* this define means that we CCP leaves code behind the (list,of,args)  */
+#define		dlog
+#endif /* not __GNUC__ */
+
+#define		print_nfs_args(nap, nfs_version)
+#define		debug_option(x)	(1)
 
 #endif /* not DEBUG */
 
 extern int debug_flags;		/* Debug options */
-extern int debug_option (char *opt);
 extern struct opt_tab dbg_opt[];
-extern void dplog(char *fmt, ...)
-     __attribute__ ((__format__ (__printf__, 1, 2)));
 
 /**************************************************************************/
 /*** MISC (stuff left to autoconfiscate)				***/
diff --git a/contrib/amd/include/am_xdr_func.h b/contrib/amd/include/am_xdr_func.h
index b50e008..c415918 100644
--- a/contrib/amd/include/am_xdr_func.h
+++ b/contrib/amd/include/am_xdr_func.h
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1997-1999 Erez Zadok
+ * Copyright (c) 1997-2006 Erez Zadok
  * Copyright (c) 1990 Jan-Simon Pendry
  * Copyright (c) 1990 Imperial College of Science, Technology & Medicine
  * Copyright (c) 1990 The Regents of the University of California.
@@ -36,12 +36,147 @@
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
- *      %W% (Berkeley) %G%
  *
- * $Id: am_xdr_func.h,v 1.2 1999/01/10 21:54:35 ezk Exp $
+ * File: am-utils/include/am_xdr_func.h
  *
  */
 
+#ifdef HAVE_FS_NFS3
+
+#define AM_FHSIZE3 64		/* size in bytes of a file handle (v3) */
+#define	AM_MOUNTVERS3 ((unsigned long)(3))
+
+/* NFSv3 handle */
+struct am_nfs_fh3 {
+  u_int am_fh3_length;
+  char am_fh3_data[AM_FHSIZE3];
+};
+typedef struct am_nfs_fh3 am_nfs_fh3;
+
+#define AM_NFSPROC3_LOOKUP ((u_long) 3)
+enum am_nfsstat3 {
+	AM_NFS3_OK = 0,
+	AM_NFS3ERR_PERM = 1,
+	AM_NFS3ERR_NOENT = 2,
+	AM_NFS3ERR_IO = 5,
+	AM_NFS3ERR_NXIO = 6,
+	AM_NFS3ERR_ACCES = 13,
+	AM_NFS3ERR_EXIST = 17,
+	AM_NFS3ERR_XDEV = 18,
+	AM_NFS3ERR_NODEV = 19,
+	AM_NFS3ERR_NOTDIR = 20,
+	AM_NFS3ERR_ISDIR = 21,
+	AM_NFS3ERR_INVAL = 22,
+	AM_NFS3ERR_FBIG = 27,
+	AM_NFS3ERR_NOSPC = 28,
+	AM_NFS3ERR_ROFS = 30,
+	AM_NFS3ERR_MLINK = 31,
+	AM_NFS3ERR_NAMETOOLONG = 63,
+	AM_NFS3ERR_NOTEMPTY = 66,
+	AM_NFS3ERR_DQUOT = 69,
+	AM_NFS3ERR_STALE = 70,
+	AM_NFS3ERR_REMOTE = 71,
+	AM_NFS3ERR_BADHANDLE = 10001,
+	AM_NFS3ERR_NOT_SYNC = 10002,
+	AM_NFS3ERR_BAD_COOKIE = 10003,
+	AM_NFS3ERR_NOTSUPP = 10004,
+	AM_NFS3ERR_TOOSMALL = 10005,
+	AM_NFS3ERR_SERVERFAULT = 10006,
+	AM_NFS3ERR_BADTYPE = 10007,
+	AM_NFS3ERR_JUKEBOX = 10008
+};
+typedef enum am_nfsstat3 am_nfsstat3;
+
+typedef struct {
+  u_int fhandle3_len;
+  char *fhandle3_val;
+} am_fhandle3;
+
+enum am_mountstat3 {
+       AM_MNT3_OK = 0,
+       AM_MNT3ERR_PERM = 1,
+       AM_MNT3ERR_NOENT = 2,
+       AM_MNT3ERR_IO = 5,
+       AM_MNT3ERR_ACCES = 13,
+       AM_MNT3ERR_NOTDIR = 20,
+       AM_MNT3ERR_INVAL = 22,
+       AM_MNT3ERR_NAMETOOLONG = 63,
+       AM_MNT3ERR_NOTSUPP = 10004,
+       AM_MNT3ERR_SERVERFAULT = 10006
+};
+typedef enum am_mountstat3 am_mountstat3;
+
+struct am_mountres3_ok {
+       am_fhandle3 fhandle;
+       struct {
+               u_int auth_flavors_len;
+               int *auth_flavors_val;
+       } auth_flavors;
+};
+typedef struct am_mountres3_ok am_mountres3_ok;
+
+struct am_mountres3 {
+       am_mountstat3 fhs_status;
+       union {
+               am_mountres3_ok mountinfo;
+       } mountres3_u;
+};
+typedef struct am_mountres3 am_mountres3;
+
+typedef char *am_filename3;
+
+struct am_diropargs3 {
+	am_nfs_fh3 dir;
+	am_filename3 name;
+};
+typedef struct am_diropargs3 am_diropargs3;
+
+struct am_LOOKUP3args {
+	am_diropargs3 what;
+};
+typedef struct am_LOOKUP3args am_LOOKUP3args;
+
+struct am_LOOKUP3resok {
+	am_nfs_fh3 object;
+#if 0
+	post_op_attr obj_attributes;
+	post_op_attr dir_attributes;
+#endif
+};
+typedef struct am_LOOKUP3resok am_LOOKUP3resok;
+
+struct am_LOOKUP3resfail {
+#if 0
+	post_op_attr dir_attributes;
+#else
+	char dummy;		/* cannot have an empty declaration */
+#endif
+};
+typedef struct am_LOOKUP3resfail am_LOOKUP3resfail;
+
+struct am_LOOKUP3res {
+	am_nfsstat3 status;
+	union {
+		am_LOOKUP3resok ok;
+		am_LOOKUP3resfail fail;
+	} res_u;
+};
+typedef struct am_LOOKUP3res am_LOOKUP3res;
+#endif /* HAVE_FS_NFS3 */
+
+/*
+ * Multi-protocol NFS file handle
+ */
+union am_nfs_handle {
+				/* placeholder for V4 file handle */
+#ifdef HAVE_FS_NFS3
+  am_nfs_fh3		v3;	/* NFS version 3 handle */
+#endif /* HAVE_FS_NFS3 */
+  am_nfs_fh		v2;	/* NFS version 2 handle */
+};
+typedef union am_nfs_handle am_nfs_handle_t;
+
+
 /*
  * Definitions of all possible xdr functions that are otherwise
  * not defined elsewhere.
@@ -99,7 +234,7 @@ bool_t xdr_ftype(XDR *xdrs, nfsftype *objp);
 bool_t xdr_groupnode(XDR *xdrs, groupnode *objp);
 #endif /* not HAVE_XDR_GROUPNODE */
 #ifndef HAVE_XDR_GROUPS
-bool_t xdr_groups(XDR *xdrs, groups objp);
+bool_t xdr_groups(XDR *xdrs, groups *objp);
 #endif /* not HAVE_XDR_GROUPS */
 #ifndef HAVE_XDR_LINKARGS
 bool_t xdr_linkargs(XDR *xdrs, nfslinkargs *objp);
@@ -110,17 +245,6 @@ bool_t xdr_mountbody(XDR *xdrs, mountbody *objp);
 #ifndef HAVE_XDR_MOUNTLIST
 bool_t xdr_mountlist(XDR *xdrs, mountlist *objp);
 #endif /* not HAVE_XDR_MOUNTLIST */
-
-/*
- * NFS3 XDR FUNCTIONS:
- */
-#if defined(HAVE_FS_NFS3) && !defined(HAVE_XDR_MOUNTRES3)
-bool_t xdr_fhandle3(XDR *xdrs, fhandle3 *objp);
-bool_t xdr_mountstat3(XDR *xdrs, mountstat3 *objp);
-bool_t xdr_mountres3_ok(XDR *xdrs, mountres3_ok *objp);
-bool_t xdr_mountres3(XDR *xdrs, mountres3 *objp);
-#endif /* defined(HAVE_FS_NFS3) && !defined(HAVE_XDR_MOUNTRES3) */
-
 #ifndef HAVE_XDR_NAME
 bool_t xdr_name(XDR *xdrs, name *objp);
 #endif /* not HAVE_XDR_NAME */
@@ -183,21 +307,21 @@ bool_t xdr_writeargs(XDR *xdrs, nfswriteargs *objp);
 #endif /* not HAVE_XDR_WRITEARGS */
 
 /*
- * AUTOFS XDR FUNCTIONS:
+ * NFS3 XDR FUNCTIONS:
  */
-#ifdef HAVE_FS_AUTOFS
-# ifndef HAVE_XDR_MNTREQUEST
-bool_t xdr_mntrequest(XDR *xdrs, mntrequest *objp);
-# endif /* not HAVE_XDR_MNTREQUEST */
-# ifndef HAVE_XDR_MNTRES
-bool_t xdr_mntres(XDR *xdrs, mntres *objp);
-# endif /* not HAVE_XDR_MNTRES */
-# ifndef HAVE_XDR_UMNTREQUEST
-bool_t xdr_umntrequest(XDR *xdrs, umntrequest *objp);
-# endif /* not HAVE_XDR_UMNTREQUEST */
-# ifndef HAVE_XDR_UMNTRES
-bool_t xdr_umntres(XDR *xdrs, umntres *objp);
-# endif /* not HAVE_XDR_UMNTRES */
-#endif /* HAVE_FS_AUTOFS */
+#ifdef HAVE_FS_NFS3
+bool_t xdr_am_fhandle3(XDR *xdrs, am_fhandle3 *objp);
+bool_t xdr_am_mountstat3(XDR *xdrs, am_mountstat3 *objp);
+bool_t xdr_am_mountres3_ok(XDR *xdrs, am_mountres3_ok *objp);
+bool_t xdr_am_mountres3(XDR *xdrs, am_mountres3 *objp);
+bool_t xdr_am_diropargs3(XDR *xdrs, am_diropargs3 *objp);
+bool_t xdr_am_filename3(XDR *xdrs, am_filename3 *objp);
+bool_t xdr_am_LOOKUP3args(XDR *xdrs, am_LOOKUP3args *objp);
+bool_t xdr_am_LOOKUP3res(XDR *xdrs, am_LOOKUP3res *objp);
+bool_t xdr_am_LOOKUP3resfail(XDR *xdrs, am_LOOKUP3resfail *objp);
+bool_t xdr_am_LOOKUP3resok(XDR *xdrs, am_LOOKUP3resok *objp);
+bool_t xdr_am_nfsstat3(XDR *xdrs, am_nfsstat3 *objp);
+bool_t xdr_am_nfs_fh3(XDR *xdrs, am_nfs_fh3 *objp);
+#endif /* HAVE_FS_NFS3 */
 
 #endif /* not _AM_XDR_FUNC_H */
diff --git a/contrib/amd/include/amq_defs.h b/contrib/amd/include/amq_defs.h
index 6564e24..75c4651 100644
--- a/contrib/amd/include/amq_defs.h
+++ b/contrib/amd/include/amq_defs.h
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1997-1999 Erez Zadok
+ * Copyright (c) 1997-2006 Erez Zadok
  * Copyright (c) 1990 Jan-Simon Pendry
  * Copyright (c) 1990 Imperial College of Science, Technology & Medicine
  * Copyright (c) 1990 The Regents of the University of California.
@@ -36,9 +36,8 @@
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
- *      %W% (Berkeley) %G%
  *
- * $Id: amq_defs.h,v 1.3 1999/09/08 23:36:52 ezk Exp $
+ * File: am-utils/include/amq_defs.h
  *
  */
 
@@ -51,7 +50,7 @@
 #ifndef AMQ_SIZE
 # define AMQ_SIZE 16384
 #endif /* not AMQ_SIZE */
-#define AMQ_STRLEN 2048
+#define AMQ_STRLEN 16384
 #define AMQ_PROGRAM ((u_long)300019)
 #define AMQ_VERSION ((u_long)1)
 #define AMQPROC_NULL ((u_long)0)
@@ -64,6 +63,7 @@
 #define AMQPROC_MOUNT ((u_long)7)
 #define AMQPROC_GETVERS ((u_long)8)
 #define AMQPROC_GETPID ((u_long)9)
+#define AMQPROC_PAWD ((u_long)10)
 
 /*
  * TYPEDEFS
diff --git a/contrib/amd/include/mount_headers1.h b/contrib/amd/include/mount_headers1.h
new file mode 100644
index 0000000..41f26e5
--- /dev/null
+++ b/contrib/amd/include/mount_headers1.h
@@ -0,0 +1,216 @@
+/*
+ * Copyright (c) 1997-2006 Erez Zadok
+ * Copyright (c) 1990 Jan-Simon Pendry
+ * Copyright (c) 1990 Imperial College of Science, Technology & Medicine
+ * Copyright (c) 1990 The Regents of the University of California.
+ * All rights reserved.
+ *
+ * This code is derived from software contributed to Berkeley by
+ * Jan-Simon Pendry at Imperial College, London.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgment:
+ *      This product includes software developed by the University of
+ *      California, Berkeley and its contributors.
+ * 4. Neither the name of the University nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ *
+ * File: am-utils/include/mount_headers1.h
+ *
+ */
+
+
+#ifdef HAVE_SYS_TYPES_H
+# include <sys/types.h>
+#endif /* HAVE_SYS_TYPES_H */
+#ifdef HAVE_SYS_ERRNO_H
+# include <sys/errno.h>
+#endif /* HAVE_SYS_ERRNO_H */
+#ifdef HAVE_SYS_PARAM_H
+# include <sys/param.h>
+#endif /* HAVE_SYS_PARAM_H */
+#ifdef HAVE_SYS_TIME_H
+# include <sys/time.h>
+#endif /* HAVE_SYS_TIME_H */
+#ifdef HAVE_SYS_UCRED_H
+# include <sys/ucred.h>
+#endif /* HAVE_SYS_UCRED_H */
+#ifdef HAVE_SYS_SOCKET_H
+# include <sys/socket.h>
+#endif /* HAVE_SYS_SOCKET_H */
+#ifdef HAVE_NETINET_IN_H
+# include <netinet/in.h>
+#endif /* HAVE_NETINET_IN_H */
+#ifdef HAVE_NET_IF_H
+# include <net/if.h>
+#endif /* HAVE_NET_IF_H */
+#ifdef HAVE_STDIO_H
+# include <stdio.h>
+#endif /* HAVE_STDIO_H */
+
+#ifndef KERNEL
+# define KERNEL_off_for_now_breaks_FreeBSD
+#endif /* not KERNEL */
+
+#ifdef HAVE_SYS_MNTENT_H
+# include <sys/mntent.h>
+#endif /* HAVE_SYS_MNTENT_H */
+#ifdef HAVE_MNTENT_H
+# include <mntent.h>
+#endif /* HAVE_MNTENT_H */
+#ifdef HAVE_SYS_MNTTAB_H
+# include <sys/mnttab.h>
+#endif /* HAVE_SYS_MNTTAB_H */
+#if defined(HAVE_MNTTAB_H) && !defined(MNTTAB)
+/*
+ * Do not include it if MNTTAB is already defined because it probably
+ * came from <sys/mnttab.h> and we do not want conflicting definitions.
+ */
+# include <mnttab.h>
+#endif /* defined(HAVE_MNTTAB_H) && !defined(MNTTAB) */
+
+#ifdef HAVE_SYS_MOUNT_H
+# ifndef NFSCLIENT
+#  define NFSCLIENT
+# endif /* not NFSCLIENT */
+# ifndef PCFS
+#  define PCFS
+# endif /* not PCFS */
+# ifndef LOFS
+#  define LOFS
+# endif /* not LOFS */
+# ifndef RFS
+#  define RFS
+# endif /* not RFS */
+# ifndef MSDOSFS
+#  define MSDOSFS
+# endif /* not MSDOSFS */
+# ifndef MFS
+#  define MFS 1
+# endif /* not MFS */
+# ifndef CD9660
+#  define CD9660
+# endif /* not CD9660 */
+# ifndef NFS
+#  define NFS
+# endif /* not NFS */
+# include <sys/mount.h>
+#endif /* HAVE_SYS_MOUNT_H */
+
+#ifdef HAVE_SYS_VMOUNT_H
+# include <sys/vmount.h>
+#endif /* HAVE_SYS_VMOUNT_H */
+
+/*
+ * There is no point in including this on a glibc2 system
+ * we're only asking for trouble
+ */
+#if defined HAVE_LINUX_FS_H && (!defined __GLIBC__ || __GLIBC__ < 2)
+/*
+ * There's a conflict of definitions on redhat alpha linux between
+ * <netinet/in.h> and <linux/fs.h>.
+ * Also a conflict in definitions of ntohl/htonl in RH-5.1 sparc64
+ * between <netinet/in.h> and <linux/byteorder/generic.h> (2.1 kernels).
+ */
+# ifdef HAVE_SOCKETBITS_H
+#  define _LINUX_SOCKET_H
+#  undef BLKFLSBUF
+#  undef BLKGETSIZE
+#  undef BLKRAGET
+#  undef BLKRASET
+#  undef BLKROGET
+#  undef BLKROSET
+#  undef BLKRRPART
+#  undef MS_MGC_VAL
+#  undef MS_RMT_MASK
+# endif /* HAVE_SOCKETBITS_H */
+# ifdef HAVE_LINUX_POSIX_TYPES_H
+#  include <linux/posix_types.h>
+# endif /* HAVE_LINUX_POSIX_TYPES_H */
+# ifndef _LINUX_BYTEORDER_GENERIC_H
+#  define _LINUX_BYTEORDER_GENERIC_H
+# endif /* _LINUX_BYTEORDER_GENERIC_H */
+# ifndef _LINUX_STRING_H_
+#  define _LINUX_STRING_H_
+# endif /* not _LINUX_STRING_H_ */
+# ifdef HAVE_LINUX_KDEV_T_H
+#  define __KERNEL__
+#  include <linux/kdev_t.h>
+#  undef __KERNEL__
+# endif /* HAVE_LINUX_KDEV_T_H */
+# ifdef HAVE_LINUX_LIST_H
+#  define __KERNEL__
+#  include <linux/list.h>
+#  undef __KERNEL__
+# endif /* HAVE_LINUX_LIST_H */
+# include <linux/fs.h>
+#endif /* HAVE_LINUX_FS_H && (!__GLIBC__ || __GLIBC__ < 2) */
+
+#ifdef HAVE_SYS_FS_TYPES_H
+# include <sys/fs_types.h>
+#endif /* HAVE_SYS_FS_TYPES_H */
+
+#ifdef HAVE_UFS_UFS_MOUNT_H
+# include <ufs/ufs_mount.h>
+#endif /* HAVE_UFS_UFS_MOUNT_H */
+#ifdef	HAVE_UFS_UFS_UFSMOUNT_H_off
+# error do not include this file here because on *bsd it
+# error causes errors with other header files.  Instead, add it to the
+# error specific conf/nfs_prot_*.h file.
+# include <ufs/ufs/ufsmount.h>
+#endif	/* HAVE_UFS_UFS_UFSMOUNT_H_off */
+
+#ifdef HAVE_CDFS_CDFS_MOUNT_H
+# include <cdfs/cdfs_mount.h>
+#endif /* HAVE_CDFS_CDFS_MOUNT_H */
+#ifdef HAVE_CDFS_CDFSMOUNT_H
+# include <cdfs/cdfsmount.h>
+#endif /* HAVE_CDFS_CDFSMOUNT_H */
+#ifdef HAVE_ISOFS_CD9660_CD9660_MOUNT_H
+# include <isofs/cd9660/cd9660_mount.h>
+#endif /* HAVE_ISOFS_CD9660_CD9660_MOUNT_H */
+
+#ifdef HAVE_SYS_FS_PC_FS_H
+# include <sys/fs/pc_fs.h>
+#endif /* HAVE_SYS_FS_PC_FS_H */
+#ifdef HAVE_MSDOSFS_MSDOSFSMOUNT_H
+# include <msdosfs/msdosfsmount.h>
+#endif /* HAVE_MSDOSFS_MSDOSFSMOUNT_H */
+#ifdef HAVE_FS_MSDOSFS_MSDOSFSMOUNT_H
+# include <fs/msdosfs/msdosfsmount.h>
+#endif /* HAVE_FS_MSDOSFS_MSDOSFSMOUNT_H */
+
+#ifdef HAVE_RPC_RPC_H
+# include <rpc/rpc.h>
+#endif /* HAVE_RPC_RPC_H */
+#ifdef HAVE_RPC_TYPES_H
+# include <rpc/types.h>
+#endif /* HAVE_RPC_TYPES_H */
+/* Prevent multiple inclusion on Ultrix 4 */
+#if defined(HAVE_RPC_XDR_H) && !defined(__XDR_HEADER__)
+# include <rpc/xdr.h>
+#endif /* defined(HAVE_RPC_XDR_H) && !defined(__XDR_HEADER__) */
+
+/* ALWAYS INCLUDE AM-UTILS' SPECIFIC NFS PROTOCOL HEADER NEXT! */
diff --git a/contrib/amd/include/mount_headers2.h b/contrib/amd/include/mount_headers2.h
new file mode 100644
index 0000000..273e89c
--- /dev/null
+++ b/contrib/amd/include/mount_headers2.h
@@ -0,0 +1,87 @@
+/*
+ * Copyright (c) 1997-2006 Erez Zadok
+ * Copyright (c) 1990 Jan-Simon Pendry
+ * Copyright (c) 1990 Imperial College of Science, Technology & Medicine
+ * Copyright (c) 1990 The Regents of the University of California.
+ * All rights reserved.
+ *
+ * This code is derived from software contributed to Berkeley by
+ * Jan-Simon Pendry at Imperial College, London.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgment:
+ *      This product includes software developed by the University of
+ *      California, Berkeley and its contributors.
+ * 4. Neither the name of the University nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ *
+ * File: am-utils/include/mount_headers2.h
+ *
+ */
+
+
+
+#ifdef HAVE_RPCSVC_MOUNT_H
+# include <rpcsvc/mount.h>
+#endif /* HAVE_RPCSVC_MOUNT_H */
+
+#ifdef HAVE_MOUNT_H
+# include <mount.h>
+#endif /* HAVE_MOUNT_H */
+
+#ifdef HAVE_NFS_NFS_GFS_H
+# include <nfs/nfs_gfs.h>
+#endif /* HAVE_NFS_NFS_GFS_H */
+
+#ifdef HAVE_NFS_MOUNT_H
+# include <nfs/mount.h>
+#endif /* HAVE_NFS_MOUNT_H */
+
+#ifdef HAVE_SYS_FS_NFS_CLNT_H
+# include <sys/fs/nfs_clnt.h>
+#endif /* HAVE_SYS_FS_NFS_CLNT_H */
+
+#ifdef HAVE_LINUX_NFS_MOUNT_H
+# ifndef _LINUX_NFS_H
+#  define _LINUX_NFS_H
+# endif /* not _LINUX_NFS_H */
+# ifndef _LINUX_NFS2_H
+#  define _LINUX_NFS2_H
+# endif /* not _LINUX_NFS2_H */
+# ifndef _LINUX_NFS3_H
+#  define _LINUX_NFS3_H
+# endif /* not _LINUX_NFS3_H */
+# ifndef _LINUX_NFS_FS_H
+#  define _LINUX_NFS_FS_H
+# endif /* not _LINUX_NFS_FS_H */
+# ifndef _LINUX_IN_H
+#  define _LINUX_IN_H
+# endif /* not _LINUX_IN_H */
+# ifndef __KERNEL__
+#  define __KERNEL__
+# endif /* __KERNEL__ */
+# include <linux/nfs_mount.h>
+# undef __KERNEL__
+#endif /* HAVE_LINUX_NFS_MOUNT_H */
